const checkType = (type) => (value) => {
    // console.log(type, value);

    if (type === null) {
        return value === null;
    } else if (typeof type === 'string') {
        return typeof value === type;
    } else if (typeof type === 'function') {
        return value instanceof type;
    } else if (typeof type === 'object') {
        return type.isPrototypeOf(value);
    }

    return false;
};

/**
 * @memberOf function
 */
const checkTypes = (values, types) => {
    return values.every((value, index) => checkType(types[index])(value));
};

export default checkTypes;